/*******************************************************************************
+
+  LEDA 5.2  
+
+
+  gw_handler.c
+
+
+  Copyright (c) 1995-2007
+  by Algorithmic Solutions Software GmbH
+  All rights reserved.
+ 
*******************************************************************************/

// $Revision: 1.2 $  $Date: 2007/02/25 00:47:47 $


#include <LEDA/graph/graph_alg.h>
#include <LEDA/graphics/graphwin.h>

using namespace leda;

void run_and_display(GraphWin& gw)
{ 
  graph& G = gw.get_graph();
  node_array<int> comp_num(G);
  STRONG_COMPONENTS(G,comp_num);
  node v;
  forall_nodes(v,G) 
    gw.set_color(v,color(comp_num[v]));
 }

void new_node_handler(GraphWin& gw, node){ run_and_display(gw); }
void new_edge_handler(GraphWin& gw, edge){ run_and_display(gw); }
void del_edge_handler(GraphWin& gw)      { run_and_display(gw); }
void del_node_handler(GraphWin& gw)      { run_and_display(gw); }
void init_graph_handler(GraphWin& gw)    { run_and_display(gw); }


int main()
{
  GraphWin gw;

  gw.set_init_graph_handler(init_graph_handler);
  gw.set_new_edge_handler(new_edge_handler);
  gw.set_del_edge_handler(del_edge_handler);
  gw.set_new_node_handler(new_node_handler);
  gw.set_del_node_handler(del_node_handler);

  gw.display();
  gw.edit();

  return 0;
}

