/*******************************************************************************
+
+  LEDA 5.2  
+
+
+  bouncing_leda.c
+
+
+  Copyright (c) 1995-2007
+  by Algorithmic Solutions Software GmbH
+  All rights reserved.
+ 
*******************************************************************************/

// $Revision: 1.2 $  $Date: 2007/02/25 00:47:49 $


#include <LEDA/graphics/window.h>
#include <LEDA/graphics/pixmaps/leda_icon.xpm>

using namespace leda;

double move_ball(window& W, circle& ball, double& dx, double& dy, 
                                        char* prect)
{ 
  ball = ball.translate(dx,dy);

  point  c = ball.center();
  double r = ball.radius();
  double r1=r, r2=r; // horizontal, vertical radii
  double C = W.pix_to_real(12);
  
  if (c.xcoord()-r +C < W.xmin() || c.xcoord()+r -C> W.xmax()) {
	dx = -dx;
  }
  if (c.ycoord()-r +C < W.ymin() || c.ycoord()+r -C> W.ymax()) {
	dy = -dy;
  }
  if (c.xcoord()-r  < W.xmin() ) {
        r1 = fabs(c.xcoord() - W.xmin());
        r2 = r + r - r1;
  }
  if (c.xcoord()+r > W.xmax()) {
        r1 = fabs(c.xcoord()  - W.xmax());
        r2 = r + r - r1;
  }           
  if (c.ycoord()-r < W.ymin() ) {
        r2 = fabs(c.ycoord()  -W.ymin());
	r1 = r + r - r2;
  }       

  if ( c.ycoord()+r > W.ymax()) {
        r2 = fabs(c.ycoord()  -W.ymax());
        r1 = r + r - r2;
  }       
  W.clear();
  W.set_clip_ellipse(c.xcoord(),c.ycoord(),r1,r2);
  W.center_pixrect(c.xcoord(),c.ycoord(),prect);
  W.reset_clipping();
  W.draw_ellipse(c, r1, r2, black);
  //if (r1 != r2) return 0; 
  return 0;
}


int main()
{ 
  //window W(300,300, "Bouncing Leda");
  window W(500,500, "Bouncing Leda");

  W.init(0,200,0);
  W.set_bg_color(grey1);
  W.display(window::center,window::center);


  circle ball(50,50,16);

  double dx = W.pix_to_real(2);
  double dy = W.pix_to_real(1);

  char* leda = W.create_pixrect(leda_icon);

  W.start_buffering();
  for(;;)
  { move_ball(W,ball,dx,dy,leda);
    W.flush_buffer();
    if (W.get_button() != NO_BUTTON) break;
    leda_wait(.01);
   }
  W.stop_buffering();

  W.del_pixrect(leda);

  return 0;
}
