/*******************************************************************************
+
+  LEDA 5.2  
+
+
+  dclock.c
+
+
+  Copyright (c) 1995-2007
+  by Algorithmic Solutions Software GmbH
+  All rights reserved.
+ 
*******************************************************************************/

// $Revision: 1.3 $  $Date: 2007/02/25 00:47:51 $


#include <LEDA/graphics/window.h>
#include <LEDA/internal/std/time.h>

using namespace leda;

bool seconds = false;

void display_time(window* wp)
{ 
  window& W = *wp;

  // get the current time
  time_t clock; 
  time(&clock);
  tm* T = localtime(&clock); 

  // and display it (centered in W)
  double  x = (W.xmax() - W.xmin())/2;
  double  y = (W.ymax() - W.ymin())/2;
  W.clear();
  string s("%2d:%02d:%02d",T->tm_hour,T->tm_min,T->tm_sec);
  W.draw_ctext(x,y,s);
  W.set_frame_label(s);
}

int main()
{
  window W(120,30, "dclock");
  //W.set_bg_color(grey1);
  W.set_font("T24");
  W.set_redraw(display_time);

  W.display(window::center,window::center);
  W.start_timer(1000,display_time);
  W.read_mouse();

  W.screenshot("dclock");
  return 0;
}
