/*******************************************************************************
+
+  LEDA 5.2  
+
+
+  event.c
+
+
+  Copyright (c) 1995-2007
+  by Algorithmic Solutions Software GmbH
+  All rights reserved.
+ 
*******************************************************************************/

// $Revision: 1.2 $  $Date: 2007/02/25 00:47:52 $


#include <LEDA/graphics/window.h>
#include <math.h>

using namespace leda;

int main()
{
  window W(450,500,"Event Demo");
  W.display();

  W.start_buffering();

  for(;;)
  { 
    // read the first corner p of the rectangle
    // terminate if the right button was clicked 

    point p;
    if (W.read_mouse(p) == MOUSE_BUTTON(3)) break;  
  
    // draw rectangle from p to current position while button down 

    int  val;
    double x,y;

    char* win_buf = W.get_window_pixrect();

    while (W.read_event(val,x,y) != button_release_event) 
    { point q(x,y);
      W.put_pixrect(win_buf);
      W.draw_box(p,q,yellow);
      W.draw_rectangle(p,q,black);
      W.flush_buffer();
     }

    W.del_pixrect(win_buf);
  }

  W.stop_buffering();

  W.screenshot("event");
  return 0;
}
