/******************************************************************************
+
+  LEDA 5.2  
+
+
+  fileview.c
+
+
+  Copyright (c) 1995-2007
+  by Algorithmic Solutions Software GmbH
+  All rights reserved.
+ 
*******************************************************************************/

// $Revision: 1.4 $  $Date: 2007/02/25 00:47:55 $

#include <LEDA/graphics/window.h>
#include <LEDA/system/file.h>

#if defined(LEDA_NAMESPACE)
using namespace leda;
#endif

#if defined(LEDA_STD_IO_HEADERS)
using std::ofstream;
using std::endl;
#endif


inline void remove_quotes(string& s)
{
	if (s.length() >= 2 && (s[0] == '\'' || s[0] == '"') 
		&& (s[0] == s[s.length()-1]))
	{ s = s(1,s.length()-2); }
}

#if defined(WINMAIN)

int main() {
  int    argc;
  char** argv;
  get_command_line(argc,argv);

#else

int main(int argc, char** argv) {

#endif

  string fname;
  string dname;
  string filter;


  //ofstream out("c:\\home\\naeher\\out");
  //for(i=0; i<argc; i++) out << argv[i] <<endl;

  if (argc > 1) fname = argv[1];
  if (argc > 2) dname = argv[2];
  if (argc > 3) filter= argv[3];

  remove_quotes(fname);
  remove_quotes(dname);
  remove_quotes(filter);

  LedaFileViewer(fname,dname,filter);

  return 0;
}
