/*******************************************************************************
+
+  LEDA 5.2  
+
+
+  except_test.c
+
+
+  Copyright (c) 1995-2007
+  by Algorithmic Solutions Software GmbH
+  All rights reserved.
+ 
*******************************************************************************/

// $Revision: 1.2 $  $Date: 2007/02/25 01:09:35 $

#include <LEDA/geo/circle.h>

using namespace leda;

#if defined(LEDA_STD_IO_HEADERS)
using std::cout;
using std::endl;
#endif

int main()
{
 // enable exceptions 
 set_error_handler(exception_error_handler);

 point p1(0,0);
 point p2(1,1);
 point p3(2,2);
 
 circle C(p1,p2,p3);
 point p;
 
 try {
  p =  C.center();
 }

 catch(leda_exception e) {
  cout << endl;
  cout << "An exception occured: " << e.get_msg() << endl;
  cout << endl;
  C = circle(point(0,0), point(1,1), point(1,0));
  p =  C.center();
 }
 
 cout << "center of circle: " << p << endl;
 
 return 0;
}
