/*******************************************************************************
+
+  LEDA 5.2  
+
+
+  hull_test.c
+
+
+  Copyright (c) 1995-2007
+  by Algorithmic Solutions Software GmbH
+  All rights reserved.
+ 
*******************************************************************************/

// $Revision: 1.2 $  $Date: 2007/02/25 01:09:36 $

#include <LEDA/geo/plane_alg.h>

using namespace leda;

#if defined(LEDA_STD_IO_HEADERS)
using std::cout;
using std::flush;
using std::endl;
#endif


int main()
{
  int N = read_int("N = ");

  list<point>      L1;
  list<rat_point>  L2;

  random_points_in_disc(N,10000,L2);
  //random_points_in_disc(N,10000,L1);

  rat_point p;
  forall(p,L2) L1.append(p.to_point());

  cout << endl;


/*
 { cout << "CONVEX_HULL(point)         " << flush;
   float T = used_time();
   list<point> C = CONVEX_HULL(L1);
   cout << string("|C| = %d   time = %.2f",C.length(),used_time(T)) << endl;
  }
 { cout << "CONVEX_HULL(rat_point)     " << flush;
   float T = used_time();
   list<rat_point> C = CONVEX_HULL(L2);
   cout << string("|C| = %d   time = %.2f",C.length(),used_time(T)) << endl;
  }
 cout << endl;
*/

 { cout << "CONVEX_HULL_IC(rat_point)  " << flush;
   float T = used_time();
   list<rat_point> C = CONVEX_HULL_IC(L2);
   cout << string("|C| = %d   time = %.2f",C.length(),used_time(T)) << endl;
  }
 rat_point::float_computation_only = 1;
 { cout << "CONVEX_HULL_IC(rat_point)  " << flush;
   float T = used_time();
   list<rat_point> C = CONVEX_HULL_IC(L2);
   cout << string("|C| = %d   time = %.2f",C.length(),used_time(T)) << endl;
  }
 rat_point::float_computation_only = 0;
 { cout << "CONVEX_HULL_IC1(rat_point) " << flush;
   float T = used_time();
   list<rat_point> C = CONVEX_HULL_IC1(L2);
   cout << string("|C| = %d   time = %.2f",C.length(),used_time(T)) << endl;
  }
  cout << endl;



 { cout << "CONVEX_HULL_S(point)       " << flush;
   float T = used_time();
   list<point> C = CONVEX_HULL_S(L1);
   cout << string("|C| = %d   time = %.2f",C.length(),used_time(T)) << endl;
  }
 { cout << "CONVEX_HULL_S(rat_point)   " << flush;
   float T = used_time();
   list<rat_point> C = CONVEX_HULL_S(L2);
   cout << string("|C| = %d   time = %.2f",C.length(),used_time(T)) << endl;
  }
  cout << endl;




  rat_point::print_statistics();
  cout << endl;

  return 0;
}
