/*******************************************************************************
+
+  LEDA 5.2  
+
+
+  gg.c
+
+
+  Copyright (c) 1995-2007
+  by Algorithmic Solutions Software GmbH
+  All rights reserved.
+ 
*******************************************************************************/

// $Revision: 1.2 $  $Date: 2007/02/25 01:11:27 $

#include <LEDA/graph/graph.h>
#include <LEDA/graph/dimacs.h>

using namespace leda;

#if defined(LEDA_STD_IO_HEADERS)
using std::cout;
using std::cerr;
using std::flush;
using std::endl;
#endif


int main(int argc, char** argv)
{
  graph G;

  if (argc < 2)
  { cerr << "usage: gg n" << endl;
    return 1;
   }

  int n = atoi(argv[1]);

  rand_int.set_seed(n);
  grid_graph(G,n);

  edge_array<int> cap(G,0);

  node s = G.first_node();
  node t = G.last_node();

  edge e;
  forall_edges(e,G) cap[e] = rand_int(1,1000);

  Write_Dimacs_MF(cout,G,s,t,cap);

  return 0;
}

