/*******************************************************************************
+
+  LEDA 5.2  
+
+
+  gml2leda.c
+
+
+  Copyright (c) 1995-2007
+  by Algorithmic Solutions Software GmbH
+  All rights reserved.
+ 
*******************************************************************************/

// $Revision: 1.2 $  $Date: 2007/02/25 01:11:28 $

// convert graph in LEDA format to GML format

#include<LEDA/graph/graph.h>
#include<LEDA/numbers/integer.h>

using namespace leda;

#if defined(LEDA_STD_IO_HEADERS)
using std::cerr;
using std::endl;
#endif



int main(int argc, char** argv)
{
  if(argc != 3)
  {
    cerr << argv[0] << ": usage is\n\t";
    cerr << argv[0] << " <file1> <file2>\nwhere <file1> contains ";
    cerr << "a graph in GML format. It is coverted and written\n";
    cerr << "to file <file2> in LEDA format.\n";
    exit(5);
  }

  GRAPH<integer,double> G;

  G.read_gml(argv[1]);

  G.write(argv[2]);

  return 0;
}
