/*******************************************************************************
+
+  LEDA 5.2  
+
+
+  gw_ortho.c
+
+
+  Copyright (c) 1995-2007
+  by Algorithmic Solutions Software GmbH
+  All rights reserved.
+ 
*******************************************************************************/

// $Revision: 1.2 $  $Date: 2007/02/25 01:12:05 $

#include <LEDA/graph/graph_draw.h>
#include <LEDA/graphics/graphwin.h>

using namespace leda;

#if defined(LEDA_STD_IO_HEADERS)
using std::cout;
using std::cin;
using std::endl;
#endif


int main()
{
   GraphWin gw;

   gw.set_node_shape(rectangle_node);

   gw.display();

   while (gw.edit())
   {
     graph& G = gw.get_graph();

     node_array<double> xpos(G);
     node_array<double> ypos(G);
     node_array<double> xrad(G);
     node_array<double> yrad(G);
     edge_array<list<double> > xbends(G);
     edge_array<list<double> > ybends(G);
     edge_array<double> xsan(G);
     edge_array<double> ysan(G);
     edge_array<double> xtan(G);
     edge_array<double> ytan(G);

     ORTHO_DRAW(G,xpos,ypos,xrad,yrad,xbends,ybends,xsan,ysan,xtan,ytan);

     double dx,dy,fx,fy;
     gw.fill_win_params(xpos,ypos,xbends,ybends,dx,dy,fx,fy);
     gw.transform_coords(xpos,ypos,xbends,ybends,dx,dy,fx,fy);

     gw.set_flush(true);
     gw.set_layout(xpos,ypos,xbends,ybends);
     gw.set_flush(false);

     node v;
     forall_nodes(v,G)
     { gw.set_radius1(v,fx*xrad[v]);
       gw.set_radius2(v,fy*yrad[v]);
      }

     edge e;
     forall_edges(e,G)
     { gw.set_source_anchor(e,point(xsan[e],ysan[e]));
       gw.set_target_anchor(e,point(xtan[e],ytan[e]));
      }

     gw.redraw();
   }

  return 0;
}


